<template>
  <div class="main-page">
    <!-- categories section -->

    <!-- choosen category -->
    <section
      class="main-page__categories main-page__categories_full column"
      style="min-height: 100px"
      v-if="
        $route.query.category != 'all' && $route.query.page && $route.query.category && checkQuery() && categoriesList
      "
    >
      <div class="row items-center justify-between q-py-lg">
        <q-btn no-caps flat icon="arrow_back" style="padding-left: 0; color: #fff" @click="$router.go(-1)">
          Back
        </q-btn>
      </div>
      <div class="row relative-position" style="height: 270px">
        <q-img
          :position="getFullCategoryImagePosition()"
          class="full-width"
          style="height: 100%"
          :src="getFullCategoryImage()"
          alt=""
        />
        <div class="absolute-left flex justify-center items-center main-page__categories-dark-bg">
          <div style="height: 50%; width: 35%; min-width: 100px; max-width: 120px">
            <q-img ratio="1" class="" style="border-radius: 8px" :src="getCategoryImage()" alt="" />

            <div class="row justify-center text-overline text-uppercase q-mt-sm relative-position">
              <span class="absolute" style="border-radius: 8px"> {{ getFullCategoryTitle() }}</span>
            </div>
          </div>
        </div>
      </div>
    </section>

    <!-- categories-list -->

    <section
      class="main-page__categories items-center row q-col-gutter-md q-py-lg wrap"
      style="min-height: 150px"
      v-else
    >
      <div class="col-xs-6 col-sm-3 col-md-2" :key="index" v-for="(category, index) in categoriesToShow">
        <CategoryCard
          @click="
            $router.push({
              name: 'Index',
              query: { sort: $route.query.sort, category: category.slug, page: $route.query.page },
            })
          "
          :title="category.title"
          :slug="category.slug"
          :imgName="category.imgName"
        >
        </CategoryCard>
      </div>
      <div class="col-xs-6 col-sm-3 col-md-2 column">
        <q-btn
          style="line-height: normal"
          v-if="!showAllCategories"
          class="text-uppercase text-overline"
          flat
          label="view all"
          @click="showAllCategories = true"
        />
      </div>
    </section>
    <!-- body section -->
    <section class="main-page__body row">
      <div class="main-page__articles articles col-8">
        <div class="articles__controls relative-position">
          <span style="color: #d8d9df" class="text-uppercase text-h4"> Articles </span>
          <div
            class="articles__sort absolute-top full-height flex items-center q-gutter-x-xl text-subtitle1"
            style="left: 125px"
          >
            <div
              :class="{ 'articles__sort-option_checked': $route.query.sort === 'new' }"
              class="articles__sort-option cursor-pointer non-selectable"
              @click="
                $router.push({
                  name: 'Index',
                  query: { sort: 'new', category: $route.query.category },
                  page: $route.query.page,
                })
              "
            >
              New
            </div>
            <div
              :class="{ 'articles__sort-option_checked': $route.query.sort === 'best' }"
              class="articles__sort-option cursor-pointer non-selectable"
              @click="
                $router.push({
                  name: 'Index',
                  query: { sort: 'best', category: $route.query.category, page: $route.query.page },
                })
              "
            >
              Best
            </div>
            <div
              :class="{ 'articles__sort-option_checked': $route.query.sort === 'trending' }"
              class="articles__sort-option cursor-pointer non-selectable"
              @click="
                $router.push({
                  name: 'Index',
                  query: { sort: 'trending', category: $route.query.category, page: $route.query.page },
                })
              "
            >
              Trending
            </div>
          </div>
        </div>
        <!-- article component -->
        <Article
          class="q-mb-lg"
          :key="index"
          v-for="(article, index) in articles.list"
          :title="article.title"
          :description="article.description"
          :categories="article.categories"
          :img_path="article.preview_img_path"
          :slug="article.slug"
          :likes="article.likes"
          @like="
            onLike(article.id);
            article.likes = article.likes + 1;
            article.isLiked = true;
          "
          :isLiked="article.isLiked"
        />

        <div class="q-pa-lg flex flex-center">
          <q-pagination
            :model-value="Number($route.query.page)"
            @update:model-value="onPageUpdate"
            :max="articles.count"
            :max-pages="5"
          />
        </div>
      </div>
      <!-- showcase component -->
      <div class="main-page__showcase showcase col column" v-if="showcaseArticle != null">
        <div class="showcase__label text-subtitle1 text-uppercase flex items-center">showcase</div>
        <div class="showcase__body bg-secondary column no-wrap">
          <div class="row showcase__category q-px-md">
            <span class="text-subtitle1">{{ showcaseArticle.categories[0] }}</span>
          </div>

          <q-img
            v-if="showcaseArticle.preview_img_path"
            class="full-width showcase__img cursor-pointer q-mb-sm"
            :src="`http://localhost:3000/${showcaseArticle.preview_img_path}`"
            alt="no way"
            @click="$router.push({ name: 'Article', params: { slug: showcaseArticle.slug } })"
          />

          <div class="row showcase__title q-px-md q-mb-sm">
            <span
              @click="$router.push({ name: 'Article', params: { slug: showcaseArticle.slug } })"
              class="text-h2 cursor-pointer"
            >
              {{ showcaseArticle.title }}
            </span>
          </div>

          <div class="row q-px-md">
            <span class="text-body2" style="color: #9fa1a8">{{ showcaseArticle.comments_count + " comments" }}</span>
          </div>

          <div class="row"></div>
        </div>
      </div>
    </section>
  </div>
</template>

<script setup>
import { ref, reactive, onMounted, watch, computed, onBeforeMount } from "vue";
import Article from "../components/Article.vue";
import { getArticles as _getArticles, getShowcase as _getShowcase, like as _like } from "../services/articleService";
import CategoryCard from "../components/CategoryCard.vue";
import { useRoute, useRouter } from "vue-router";

const route = useRoute();
const router = useRouter();
const articles = reactive({ list: [], count: 5 });
const showcaseArticle = ref(null);

const showAllCategories = ref(false);
const categoriesList = require("../services/categories.json").categories;

const categoriesToShow = computed(() => {
  return categoriesList.filter((value, index) => {
    if (!showAllCategories.value) {
      return index <= 4;
    } else {
      return true;
    }
  });
});
async function onLike(articleId) {
  const success = await _like(articleId);
  if (!success) {
    return;
  }
  if (!localStorage.getItem("likes")) {
    localStorage.setItem("likes", articleId);
  } else {
    localStorage.setItem("likes", `${localStorage.getItem("likes")},${articleId}`);
  }
}
async function onPageUpdate(value) {
  await router.push({
    name: "Index",
    query: { sort: route.query.sort, category: route.query.category, page: value },
  });
}
async function getShowcase() {
  return await _getShowcase();
}

function getFullCategoryImage() {
  try {
    const imgName = categoriesList.filter((value) => {
      return value.slug === route.query.category;
    })[0].bigImgName;
    return `${require(`src/assets/img/${imgName}.png`)}`;
  } catch {}
}
function getFullCategoryImagePosition() {
  try {
    return categoriesList.filter((value) => {
      return value.slug === route.query.category;
    })[0].position;
  } catch {}
}
function getCategoryImage() {
  try {
    const imgName = categoriesList.filter((value) => {
      return value.slug === route.query.category;
    })[0].imgName;
    return `${require(`src/assets/img/${imgName}.png`)}`;
  } catch {}
}

function getFullCategoryTitle() {
  try {
    return categoriesList.filter((value) => {
      return value.slug === route.query.category;
    })[0].title;
  } catch {}
}
async function checkQuery() {
  const sorts = ["new", "best", "trending"];
  const categories = categoriesList.map((value) => {
    return value.slug;
  });

  if (
    !sorts.includes(route.query.sort) ||
    !(articles.count >= route.query.page && route.query.page >= 1) ||
    !(categories.includes(route.query.category) || route.query.category === "all")
  ) {
    return false;
  }
  return true;
}

async function getArticles(sort, category, page) {
  if (!sort || !category || !page) {
    return;
  }
  const checkResult = await checkQuery();
  if (!checkResult) {
    router.push({ name: "Index", query: { sort: "new", category: "all", page: "1" } });
  }
  const newArticles = await _getArticles(sort, category, page);
  if (newArticles) {
    articles.list = newArticles.rows;
    let pages;
    pages = Math.floor(newArticles.count / 5);
    if (newArticles.count % 5) {
      pages++;
    }
    articles.count = pages;
  }

  const articleLikes = localStorage.getItem("likes").split(",");
  console.log("artLikes:", articleLikes);

  articles.list.forEach((article, index, array) => {
    if (articleLikes.find((el) => el == article.id)) {
      array[index].isLiked = true;
    }
  });
}
onBeforeMount(() => {
  if (!route.query.sort || !route.query.category || !route.query.page) {
    router.push({ name: "Index", query: { sort: "new", category: "all", page: "1" } });
  }
});
onMounted(() => {
  getArticles(route.query.sort, route.query.category || "all", route.query.page);
  getShowcase().then((res) => {
    showcaseArticle.value = res.showcase_post;
  });
});
watch(
  () => {
    return route.query.sort;
  },
  async (newSort, oldSort) => {
    await getArticles(newSort, route.query.category || "all", route.query.page);
  }
);

watch(
  () => {
    return route.query.category;
  },
  async (newCategory, oldCategory) => {
    await getArticles(route.query.sort, newCategory || "all", route.query.page);
  }
);

watch(
  () => {
    return route.query.page;
  },
  async (newPage, oldPage) => {
    await getArticles(route.query.sort, route.query.category || "all", newPage);
  }
);
</script>

<style lang="scss" scoped>
.main-page {
  &__categories {
    padding-left: 15.27vw;
    padding-right: 15.27vw;
    background-color: #272930;
  }
  &__categories-dark-bg {
    background: rgba(0, 0, 0, 0.2);
    width: 33%;
    height: 100%;
    min-width: 215px;
    @media (max-width: 490px) {
      width: 100%;
    }
  }
  &__body {
    background-color: #202227;
    padding-left: 15.27vw;
    padding-right: 15.27vw;
    padding-top: 50px;
  }
  &__showcase {
    height: auto;
  }
  @media (max-width: 1200px) {
    &__categories {
      padding-left: 6.27vw;
      padding-right: 6.27vw;
    }
    &__body {
      padding-left: 6.27vw;
      padding-right: 6.27vw;
    }
    .articles {
      margin-right: 8vw !important;
    }
  }
  @media (max-width: 800px) {
    .articles {
      margin-right: 0 !important;
      flex: 100%;
    }
    .showcase {
      display: none;
    }
  }

  .showcase {
    &__label {
      height: 30px;
      margin-bottom: 40px;
    }
    &__body {
      border-radius: 8px;
      padding-top: 24px;
      padding-bottom: 14px;
    }
    &__category {
      margin-bottom: 27px;
    }
  }
  .articles {
    margin-right: 2vw;
    width: 50vw;
    &__controls {
      margin-bottom: 40px;
    }
    &__sort-option {
      color: #d8d9df;
      &_checked {
        position: relative;
        color: #fff;
        &::after {
          content: "";
          position: absolute;
          background-image: url(../assets/svg/ok.svg);
          background-repeat: no-repeat;
          height: 22px;
          width: 22px;
          left: 110%;
        }
      }
    }
  }
}
</style>
